/* ckaliases - verify syntax of sendmail-style alias files
   Copyright (C) 2005 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program. If not, see <http://www.gnu.org/licenses/>. */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#define obstack_chunk_alloc malloc
#define obstack_chunk_free free
#include <obstack.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>	
#include <unistd.h>  
#include <sys/file.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include "getopt.h"
#include "progname.h"
#include "error.h"
#include "xalloc.h"

extern char *file_name;
extern int line_num;
extern int error_count;

void init_lex ();
void lex_debug (int n);
void openaliases (char *name);
void openaliases_prefix (char *prefix, char *name);

struct string_list
{
  struct string_list *next;
  char *str;
};

typedef struct slist
{
  struct string_list *head, *tail;
  int count;
} SLIST;

void slist_add (SLIST ** plist, char *str);
void slist_append (SLIST ** pdst, SLIST * src);
char *slist_member (SLIST * plist, char *name);
void slist_destroy (SLIST ** plist);

void read_include (SLIST ** plist, char *name);

void regalias (char *name, SLIST * exp);
void begin_aliases (void);
void end_aliases (void);

extern SLIST *cw_list;
extern int verbose;
